/* -*-C++-*-
                                                                               
 
  File:         main.cc
  RCS:          $Header: $
  Description:  
  Author:       Erwin Dieterich
  Created:      Sun Dec 27 02:09:46 1998
  Modified:     Mon Jan 11 21:55:38 1999 (Erwin Dieterich) bamse@gmx.de
  Language:     C++
  Package:      nameread
  Status:       Experimental (Do Not Distribute)
 
  (C) Copyright 1998-1999, Erwin Dieterich, all rights reserved.
 
                                                                               
*/

//   Main program to test nameread

#include <stream.h>
#include <dirent.h>
#include <unistd.h>

int nameread(char *filename, int *length);

// Look for ttf-files
int ttfselect(const struct dirent * d_entry)
{
  int   n;

  n = strlen(d_entry->d_name);
  if (n < 5)      /* Endung ".ttf" + 1 Buchstabe = 5 */
    return (0);
    
  /* Hier also > 4 */
  if ( strcmp(&d_entry->d_name[n-4],".ttf") && 
       strcmp(&d_entry->d_name[n-4],".TTF") && 
       strcmp(&d_entry->d_name[n-4],".txx"))    // ".txx" is for SoftMaker CDs
    return (0);  /* entry->d_name endet _nicht_ auf .ttf */
      
  return (1);    /* entry->d_name endet auf .ttf */

}


main()
{
  
  char filename[256], stringf[256];
  int  i, l, err, length;
  
  struct dirent **namelist;
  int   num_files;
  char  ttfdir[PATH_MAX];  // is this safe ??


  //Look in the current directory or ttfdir for ".ttf"-files 
  getcwd(ttfdir,PATH_MAX);
  num_files = scandir(ttfdir, &namelist, ttfselect, alphasort);
  if ( num_files == 0 ) 
    {
      cout << "\nNo TrueType Files in this directory (" <<
	ttfdir << ").\n\n";
      exit(0);
    }
  cout << "\n" << num_files << " TTF-Files in Directory " << ttfdir << "\n\n";

  for (i=0; i<num_files; i++)
    {
      strcpy (filename, namelist[i]->d_name );
      strcpy (stringf, filename);

      length=256;
      err = nameread(stringf, &length);
      if (err != 0)
	{
	  cout << "Error in nameread: " << filename << "\n";
	  cout << "Error: " << err << "\n";
	}

      // Ugly conversion Unicode -> ASCII
      for ( l=0; l<length/2; l++)
	stringf[l] = stringf[2*l+1];
      
      stringf[length/2] = '\0';
      
      cout << filename << ": " << stringf << "\n";
    }

  cout << "\n";

  exit(0);

}

