/* -*-C-*-
                                                                               
 
  File:         compare.c
  RCS:          $Header: $
  Description:  
  Author:       Erwin Dieterich
  Created:      Mon Jan 11 20:35:28 1999
  Modified:     Mon Jan 11 23:01:29 1999 (Erwin Dieterich) bamse@gmx.de
  Language:     C
  Package:      nameread
  Status:       Experimental (Do Not Distribute)
 
  (C) Copyright 1999, Erwin Dieterich, all rights reserved.
 
                                                                               
*/

/*   Main program to compare the performance of nameread with FreeType*/

#include <stdio.h>
#include <dirent.h>
#include <unistd.h>

int nameread(char *filename, int *length);

/* Look for ttf-files */
int ttfselect(const struct dirent * d_entry)
{
  int   n;

  n = strlen(d_entry->d_name);
  if (n < 5)      /* Endung ".ttf" + 1 Buchstabe = 5 */
    return (0);
    
  /* Hier also > 4 */
  if ( strcmp(&d_entry->d_name[n-4],".ttf") && 
       strcmp(&d_entry->d_name[n-4],".TTF") && 
       strcmp(&d_entry->d_name[n-4],".txx"))    /* ".txx" is for SoftMaker CDs */
    return (0);  /* entry->d_name endet _nicht_ auf .ttf */
      
  return (1);    /* entry->d_name endet auf .ttf */

}


int main()
{
  
  char filename[256], stringf[256];
  int  i, l, err, length;
  
  struct dirent **namelist;
  int   num_files;
  char  ttfdir[PATH_MAX];  /* is this safe ?? */


  /* Look in the current directory or ttfdir for ".ttf"-files */
  getcwd(ttfdir,PATH_MAX);
  num_files = scandir(ttfdir, &namelist, ttfselect, alphasort);
  if ( num_files == 0 ) 
    {
      printf("\nNo TrueType Files in this directory (%s).\n\n",ttfdir);
      exit(0);
    }
  printf("\n%i TTF-Files in Directory %s \n\n", num_files, ttfdir);

  for (i=0; i<num_files; i++)
    {
      strcpy (filename, namelist[i]->d_name );
      strcpy (stringf, filename);

      length=256;
      err = nameread(stringf, &length);
      if (err != 0)
	{
	  printf("Error in nameread: %s\n", filename);
	  printf("Error: %i\n", err);
	}

      /* Ugly conversion Unicode -> ASCII */
      for ( l=0; l<length/2; l++)
	stringf[l] = stringf[2*l+1];
      
      stringf[length/2] = '\0';
      
      printf ("%s: %s \n", filename, stringf);
    }

  printf("\n");

  exit(0);

}

